#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#if defined(WIN32)
#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif
#include "menu.h"

/* gbN{[p֐̐錾 */
#include "trackball.h"

/*
** 
*/
static const GLfloat lpos[] = { 0.0, 0.0, 1.0, 0.0 };   /* ʒu@@@@ */
static const GLfloat lcol[] = { 1.0, 1.0, 1.0, 1.0 };   /* ڌx@ */
static const GLfloat lamb[] = { 0.2, 0.2, 0.2, 1.0 };   /* x@ */

/*
** }eA
*/
static const GLfloat kdiff[] = { 0.0, 0.1, 0.3, 1.0 };  /* gUˌW */
static const GLfloat kspec[] = { 0.6, 0.6, 0.6, 1.0 };  /* ʔˌW */
static const GLfloat kshi = 20.0;                       /* PW@@ */

/*
** eNX`̍쐬
*/
void makeTexture(unsigned char *t, int w, int h, int func)
{
  /* xNgƎxNg̒ԃxNg (hx, hy, hz) ߂ */
  float l2 = lpos[0] * lpos[0] + lpos[1] * lpos[1] + lpos[2] * lpos[2];
  float l = sqrt(l2);
  float hx = lpos[0], hy = lpos[1], hz = lpos[2] + l;
  
  l2 += lpos[2] * l;
  if (l2 > 0.0) {
    double m = sqrt(l2 + l2);
    hx /= m;
    hy /= m;
    hz /= m;
  }
	
  /* ԃxNgƖ@xNg̓ϒlŃeNX` */
  for (int y = 0; y < h; ++y) {
    float ny = (float)(y + y - h) / (float)h;
    float ny2 = ny * ny;
    
    for (int x = 0; x < w; ++x) {
      float nx = (float)(x + x - w) / (float)w;
      float nx2 = nx * nx;
      float nz2 = 1.0 - nx2 - ny2;
      
      /* nz2 >= 0 Ȃu~v */
      if (nz2 >= 0.0) {
        float nz = sqrt(nz2), rs;

        switch (func) {
        case 0:
          rs = pow(hx * nx + hy * ny + hz * nz, kshi) * 255.0;
          break;
        case 1:
          rs = (hx * nx + hy * ny + hz * nz > 0.97) ? 255.0 : 0.0;
          break;
        case 2:
          rs = hx * nx - hy * ny - hz * nz;
				  rs = pow(1.0 - rs * rs, 5.0) * 255.0;
          break;
        default:
          rs = 1.0;
          break;
        }

        *(t++) = (GLubyte)(kspec[0] * rs * lcol[0]);
        *(t++) = (GLubyte)(kspec[1] * rs * lcol[1]);
        *(t++) = (GLubyte)(kspec[2] * rs * lcol[2]);
      }
      else {
        *(t++) = 0;
        *(t++) = 0;
        *(t++) = 0;
      }
    }
  }

#if 0
  FILE *fp = fopen("aaa.raw", "wb");
  if (fp) {
    fwrite(t - sizeof(unsigned char) * 3 * w * h, sizeof(unsigned char) * 3, w * h, fp);
    fclose(fp);
  }
#endif
}

/*
** 
*/
static void init(void)
{
  /* eNX`̓ǂݍ݂Ɏgz */
  static GLubyte texture[TEXHEIGHT * TEXWIDTH * 3];

  /* eNX`̍쐬 */
  makeTexture(texture, TEXWIDTH, TEXHEIGHT, 0);

  /* eNX`摜̓oCgPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  
  /* eNX`̊蓖 */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TEXWIDTH, TEXHEIGHT, 0,
    GL_RGB, GL_UNSIGNED_BYTE, texture);
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);

  /* XtBA}bsO */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
  
  /* eNX`i|S̉AeɉZj */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lamb);

  /* gUˌƋʔˌʁXɕԂ */
  glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SEPARATE_SPECULAR_COLOR);
  
  /* ̑̏ݒ */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
}

/*
** V[̕`
*/
static void scene(void)
{
  /* ʔːeNX`}bsOƂ̋ʔˌW */
  static const GLfloat knone[] = { 0.0, 0.0, 0.0, 1.0 };
  
  /* ގ̐ݒ */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, kdiff);
  glMaterialf(GL_FRONT, GL_SHININESS, kshi);
  
  /* eNX`}bsOɐ}`` */
  glMaterialfv(GL_FRONT, GL_SPECULAR, kspec);
  glPushMatrix();
  glTranslated(-1.7, 0.0, 0.0);
  glMultMatrixd(trackballRotation());
  showShape();
  glPopMatrix();

  /* eNX`}bsOĐ}`` */
  glMaterialfv(GL_FRONT, GL_SPECULAR, knone);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glPushMatrix();
  glTranslated( 1.7, 0.0, 0.0);
  glMultMatrixd(trackballRotation());
  showShape();
  glPopMatrix();
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_2D);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

static void display(void)
{
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* fr[ϊs̏ */
  glLoadIdentity();
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lpos);
  
  /* _̈ړ */
  glTranslated(0.0, 0.0, -7.5);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(30.0, (GLdouble)w / (GLdouble)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInitWindowSize(480, 240);
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  menu();
  glutMainLoop();
  return 0;
}